#!/usr/bin/python2

import generic_tla_monitoring
import os, pdb


special_plugin_description      = "OAI-PMH endpoint"
special_plugin_file_name        = os.path.basename(__file__)
OAI_NAMESPACE                   = "http://www.openarchives.org/OAI/2.0/"
command_line_parameters = [("-h", "host",),
                           ("-u", "URL",)]

# Warning: check of validity of returned data relies on the XML namespace OAI_NAMESPACE of the returned XML markup.

def special_main_subroutine(host, 
                            URL) :

    UP_URLs = (URL,) # X- use frozenset

    valid_root_element_tag  = "{%s}OAI-PMH" % ("http://www.openarchives.org/OAI/2.0/")
    
    # Check status for all UP_URLs.
    results          = map(lambda UP_URL : generic_tla_monitoring.check_condition(host                      = host,
                                                                                  UP_URL                    = UP_URL,
                                                                                  HTTP_method               = 'GET',
                                                                                  validator                 = generic_tla_monitoring.check_XML_validity,
                                                                                  valid_root_element_tag    = valid_root_element_tag,
                                                                                  special_plugin_file_name  = special_plugin_file_name),
                           UP_URLs)   
    
    generic_tla_monitoring.nagios_return_complex(results, reporter = special_plugin_description)

if __name__ == "__main__" :
    generic_tla_monitoring.main(special_main_subroutine, 
                                command_line_parameters)
